﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace TestProject;

/// <summary>
/// 메인 윈도우
/// </summary>
public partial class MainWindow : Window
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Field
    ////////////////////////////////////////////////////////////////////////////////////////// Private

    #region Field

    /// <summary>
    /// 회전 여부
    /// </summary>
    private bool isRotating = false;

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 생성자 - MainWindow()

    /// <summary>
    /// 생성자
    /// </summary>
    public MainWindow()
    {
        InitializeComponent();

        this.gearButton1.Click += settingButton_Click;
        this.gearButton2.Click += settingButton_Click;
        this.gearButton3.Click += settingButton_Click;
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Private

    #region 기어 버튼 클릭시 처리하기 - settingButton_Click(sender, e)

    /// <summary>
    /// 기어 버튼 클릭시 처리하기
    /// </summary>
    /// <param name="sender">이벤트 발생자</param>
    /// <param name="e">이벤트 인자</param>
    private void settingButton_Click(object sender, RoutedEventArgs e)
    {
        if(!this.isRotating)
        {
            this.isRotating = true;

            Button button = sender as Button;

            Path gearPath = (Path)button.Template.FindName("gearPath", button);

            RotateTransform rotateTransform = gearPath.RenderTransform as RotateTransform;

            DoubleAnimation rotateBackAnimation = new DoubleAnimation
            {
                Duration = TimeSpan.FromSeconds(0.2),
                From     = 180,
                To       = 0
            };

            rotateBackAnimation.Completed += (s, _) =>
            {
                this.isRotating = false;

                rotateTransform.Angle = 0;
            };

            rotateTransform.BeginAnimation(RotateTransform.AngleProperty, rotateBackAnimation);
        }
    }

    #endregion
}